//
//  AsBarcodeItem.swift
//  AsReaderGUN
//
//  Created by mac on 2018/7/10.
//  Copyright © 2018年 asterisk. All rights reserved.
//

import UIKit

final class AsBarcodeItem: NSObject, NSCoding {
    public var barcodeType  = BarcodeType.RawValue()
    public var codeId = ""
    public var barcode = ""
    public var dateTime = ""

    func encode(with aCoder: NSCoder) {
        aCoder.encode(barcodeType, forKey: "barcodeType")
        aCoder.encode(codeId, forKey: "codeId")
        aCoder.encode(barcode, forKey: "barcode")
        aCoder.encode(dateTime, forKey: "dateTime")
    }
    required init?(coder aDecoder: NSCoder) {
        super.init()
        barcodeType = (aDecoder.decodeObject(forKey: "barcodeType") as? BarcodeType.RawValue) ?? BarcodeTypeNoRead.rawValue
        codeId = (aDecoder.decodeObject(forKey: "codeId" ) as? String) ?? ""
        barcode = (aDecoder.decodeObject(forKey: "barcode" ) as? String) ?? ""
        dateTime = (aDecoder.decodeObject(forKey: "dateTime" ) as? String) ?? ""
    }
    
    init(barcodeType: BarcodeType, codeId: String, barcode: String, dateTime: String) {
        self.barcodeType = barcodeType.rawValue
        self.codeId = codeId
        self.barcode = barcode
        self.dateTime = dateTime
        super.init()
        
    }
    override init() {
        super.init()
    }
}
